' Licensed Materials - Property of IBM
'
' Remote Execution & Access (RXA)
'
' (C) COPYRIGHT International Business Machines Corp. 2010
'
' All Rights Reserved
' US Government Users Restricted Rights - Use duplication or
' disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
'
'
' Returns a timestamp of file or directory

const SUCCESS = 254
const BAD_ARG_COUNT = 1
const INVALID_PATH = 3
const INVALID_ARG_ENCODING = 10

Dim objWMIService, objFile, objFiles, dateModified, encodedFileName, fileName, fileFound

On Error Resume Next
fileFound = False

Set args = WScript.Arguments
If args.count <> 1 Then
	WScript.StdErr.WriteLine "0"
	WScript.StdErr.WriteLine "Count: " & args.count
    Wscript.Quit(BAD_ARG_COUNT)
End If

encodedFileName = args.Item(0)
fileName = decodeUnicodeString(encodedFileName)
chkErr(encodedFileName)

Set objWMIService = GetObject("winmgmts:" _
    & "{impersonationLevel=impersonate}!\\" _
    & ".\root\cimv2")

Set colFiles = objWMIService.ExecQuery _
("Select * from CIM_LogicalFile Where name = '" & fileName & "'")

For Each objFile in colFiles
	fileFound = True
	Wscript.Echo objFile.LastModified
	Exit For
Next

If Not fileFound then
	WScript.StdErr.WriteLine "0"
	WScript.StdErr.WriteLine encodedFileName
	Wscript.Quit(INVALID_PATH)
End If

chkErr(encodedFileName)
Wscript.Quit(SUCCESS)

Function decodeUnicodeString(encodedString)
	Dim tempChar, i, hexChar, encChar
	For i = 1 to Len(encodedString) step 6
    		tempChar = Mid(encodedString, i, 6)
		If Len(tempChar) = 6 Then
			If Mid(tempChar, 1, 2) = "\u" Then
				hexChar = Mid(tempChar, 3, 4)
				encChar = ChrW(CInt("&H" & hexChar))
				decodeUnicodeString = decodeUnicodeString & encChar
			End If
		Else
			WScript.StdErr.WriteLine "0"
			WScript.StdErr.WriteLine "Format error: " & tempChar
			Wscript.Quit(INVALID_ARG_ENCODING)
		End If
	Next
End Function


Function chkErr(fileName)
    If Err > 0 Then
        WScript.StdErr.WriteLine Err.number
        WScript.StdErr.WriteLine Err.Description & ", file: " & fileName
        Wscript.Quit(0)
    End If
End Function